//## begin module%1.2%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.2%.codegen_version

//## begin module%3F7BD7AC0102.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3F7BD7AC0102.cm

//## begin module%3F7BD7AC0102.cp preserve=no
//## end module%3F7BD7AC0102.cp

//## Module: TProgressBar%3F7BD7AC0102; Pseudo Package body
//## Source file: C:\Program Files\Rational\Rose 2000\C++\source\TProgressBar.cpp

//## begin module%3F7BD7AC0102.additionalIncludes preserve=no
//## end module%3F7BD7AC0102.additionalIncludes

//## begin module%3F7BD7AC0102.includes preserve=yes
//## end module%3F7BD7AC0102.includes

// TProgressBar
#include "ProgressBar.hpp"

RectangleType r;

//## begin module%3F7BD7AC0102.additionalDeclarations preserve=yes
//## end module%3F7BD7AC0102.additionalDeclarations

// Class TProgressBar 







TProgressBar::TProgressBar()
  //## begin TProgressBar::TProgressBar%3F7BD7AC0102_const.hasinit preserve=no
  //## end TProgressBar::TProgressBar%3F7BD7AC0102_const.hasinit
  //## begin TProgressBar::TProgressBar%3F7BD7AC0102_const.initialization preserve=yes
  //## end TProgressBar::TProgressBar%3F7BD7AC0102_const.initialization
{
	Max = 100; //  
	wRec = 3; //  
	hRec = 2; //  
	PrgsWidth = 130; //  
  //## begin TProgressBar::TProgressBar%3F7BD7AC0102_const.body preserve=yes
  //## end TProgressBar::TProgressBar%3F7BD7AC0102_const.body
}

TProgressBar::TProgressBar(const TProgressBar &right)
  //## begin TProgressBar::TProgressBar%3F7BD7AC0102_copy.hasinit preserve=no
  //## end TProgressBar::TProgressBar%3F7BD7AC0102_copy.hasinit
  //## begin TProgressBar::TProgressBar%3F7BD7AC0102_copy.initialization preserve=yes
  //## end TProgressBar::TProgressBar%3F7BD7AC0102_copy.initialization
{
  //## begin TProgressBar::TProgressBar%3F7BD7AC0102_copy.body preserve=yes
  //## end TProgressBar::TProgressBar%3F7BD7AC0102_copy.body
}


TProgressBar::~TProgressBar()
{
  //## begin TProgressBar::~TProgressBar%3F7BD7AC0102_dest.body preserve=yes
  //## end TProgressBar::~TProgressBar%3F7BD7AC0102_dest.body
}


TProgressBar & TProgressBar::operator=(const TProgressBar &right)
{
  //## begin TProgressBar::operator=%3F7BD7AC0102_assign.body preserve=yes
  //## end TProgressBar::operator=%3F7BD7AC0102_assign.body
}


int TProgressBar::operator==(const TProgressBar &right) const
{
  //## begin TProgressBar::operator==%3F7BD7AC0102_eq.body preserve=yes
  //## end TProgressBar::operator==%3F7BD7AC0102_eq.body
}

int TProgressBar::operator!=(const TProgressBar &right) const
{
  //## begin TProgressBar::operator!=%3F7BD7AC0102_neq.body preserve=yes
  //## end TProgressBar::operator!=%3F7BD7AC0102_neq.body
}



//## Other Operations (implementation)
void TProgressBar::Show ()
{
  //## begin TProgressBar::Show%3F7BDE1901D3.body preserve=yes
  //## end TProgressBar::Show%3F7BDE1901D3.body
}

void TProgressBar::Hide ()
{
  //## begin TProgressBar::Hide%3F7BDE1E03A7.body preserve=yes
  WinEraseRectangle(&r, 10);  
  //## end TProgressBar::Hide%3F7BDE1E03A7.body
}

void TProgressBar::Start (Int32 pos, Int32 max, Char caption[50])
{
  //## begin TProgressBar::Start%3F7BDFBA020D.body preserve=yes
    RectangleType rm;
	Int32 left;
    Int32 lPos;
	Int32 i;
	Int32 rectPos;
	
	Rectcount = PrgsWidth/(wRec + 1);
	r.extent.x = 160 - 20; 
	r.extent.y = 30;
	r.topLeft.x = (160 - r.extent.x) / 2; 
	r.topLeft.y = (160 - r.extent.y) / 2;
	rm.extent.x = r.extent.x - 2; 
	rm.extent.y = r.extent.y - 2;
	rm.topLeft.x = r.topLeft.x + 1; 
	rm.topLeft.y = r.topLeft.y + 1;
	WinSetForeColor (15);
    WinDrawRectangle (&r, 10);
	WinSetForeColor (0);
    WinDrawRectangle (&rm, 10);
	WinSetForeColor (15);
	
	Max = max;
	Position = 0;
	
	Progress(pos, caption);
  
  //## end TProgressBar::Start%3F7BDFBA020D.body
}

void TProgressBar::Progress (UInt16 pos, Char caption[50])
{
  //## begin TProgressBar::Progress%3F7BE012002A.body preserve=yes
	Int32 left;
    Int32 lPos;
	Int32 rectPos;
	Int32 i;
	RectangleType rm;
	
	//lPos = max % pos;
	if  (StrLen(caption)!=0){
		rm.extent.x = r.extent.x - 2; 
		rm.extent.y = 15;
		rm.topLeft.x = r.topLeft.x + 1; 
		rm.topLeft.y = r.topLeft.y + 1;
		WinSetForeColor (0);
	    WinDrawRectangle (&rm, 10);
		left = r.topLeft.x + (r.extent.x - FntLineWidth (caption, StrLen(caption)))/2;
		WinDrawChars (caption, StrLen(caption), left, r.topLeft.y + 3 );
	}
		
	if (Max <= 0) Max = 1;
	lPos = pos % Max;
	/*if (pos != 0) lPos = pos % Max;
	else lPos = 0;*/
	
	WinSetForeColor (15);
	rectPos = lPos * Rectcount / Max + 1;  
	if 	(rectPos != Position){
      for(i = Position; i <= rectPos; ++i){
		rm.extent.x = wRec; 
		rm.extent.y = hRec;
		rm.topLeft.x = r.topLeft.x + 5 + i*(wRec + 1); 
		rm.topLeft.y = r.topLeft.y + 20;
	    WinDrawRectangle (&rm, 0);
	  }
	  Position = rectPos; 
	}      
  //## end TProgressBar::Progress%3F7BE012002A.body
}

// Additional Declarations
  //## begin TProgressBar%3F7BD7AC0102.declarations preserve=yes
  //## end TProgressBar%3F7BD7AC0102.declarations

//## begin module%3F7BD7AC0102.epilog preserve=yes
//## end module%3F7BD7AC0102.epilog
