// TComboBox
#include "TComboBox.hpp"
// Class TComboBox 
TComboBox::TComboBox()
      : ItemIndex(-1)
{
}

TComboBox::TComboBox(const TComboBox &right)
      : ItemIndex(-1)
{
}

TComboBox::TComboBox (ListType* aPList, ControlPtr aPPopupTr)
      : ItemIndex(-1)
{
  PList = aPList;
  PPopupTr = aPPopupTr;
  PForm = FrmGetActiveForm();
  indexPT = GetObjectIndexFromPtr (PForm, PPopupTr);
  OnChange = NULL;
}


TComboBox::~TComboBox()
{
}


TComboBox & TComboBox::operator=(const TComboBox &right)
{
}


int TComboBox::operator==(const TComboBox &right) const
{
}

int TComboBox::operator!=(const TComboBox &right) const
{
}



Boolean TComboBox::ctlSelectEventHandler (EventPtr event)
{
  Char *lstText;
  RectangleType rP;
  Int16 newItemIndex;
  
  FrmGetObjectBounds (PForm, indexPT, &rP); 
  LstSetPosition(PList, rP.topLeft.x, rP.topLeft.y);
  newItemIndex = LstPopupList(PList);
  
  if (newItemIndex == -1) return true;
  //  
  //   
  if (OnChange) OnChange(newItemIndex);
  ItemIndex = newItemIndex; 
  lstText = LstGetSelectionText (PList, ItemIndex);
  CtlSetLabel(PPopupTr, lstText);
  
  return true;

}
