#ifndef TComboBox_h
#define TComboBox_h 1
#include <PalmOS.h> 
#include "CommonFunc.hpp" 

class TComboBox 
{

  public:
      TComboBox();

      TComboBox(const TComboBox &right);

      TComboBox (ListType* aPList, ControlPtr aPPopupTr	// POPUPTRIGGER
      );
	  
      ~TComboBox();

    //## Assignment Operation (generated)
      TComboBox & operator=(const TComboBox &right);

    //## Equality Operations (generated)
      int operator==(const TComboBox &right) const;

      int operator!=(const TComboBox &right) const;


    //## Other Operations (specified)
      //## Operation: ctlSelectEventHandler%3FA2552A00D3
      Boolean ctlSelectEventHandler (EventPtr event);

    //## Get and Set Operations for Class Attributes (generated)

      //## Attribute: PList%3FA254A0005A
      //	 
      const ListType* get_PList () const;
      void set_PList (ListType* value);

      //## Attribute: PPopupTr%3FA254B601F7
      const ControlPtr get_PPopupTr () const;
      void set_PPopupTr (ControlPtr value);

      //## Attribute: ItemIndex%3FA256480243
      const Int32 get_ItemIndex () const;
      void set_ItemIndex (Int32 value);
	  
	  void (*OnChange)(Int16 aItemIndex); //    
  protected:

  private:

  private: //## implementation
      ListType* PList;
      ControlPtr PPopupTr;
      Int16 ItemIndex;
	  FormPtr PForm;
	  UInt16 indexPT; 
};

// Class TComboBox 

inline const ListType* TComboBox::get_PList () const
{
  //## begin TComboBox::get_PList%3FA254A0005A.get preserve=no
  return PList;
  //## end TComboBox::get_PList%3FA254A0005A.get
}

inline void TComboBox::set_PList (ListType* value)
{
  //## begin TComboBox::set_PList%3FA254A0005A.set preserve=no
  PList = value;
  //## end TComboBox::set_PList%3FA254A0005A.set
}

inline const ControlPtr TComboBox::get_PPopupTr () const
{
  //## begin TComboBox::get_PPopupTr%3FA254B601F7.get preserve=no
  return PPopupTr;
  //## end TComboBox::get_PPopupTr%3FA254B601F7.get
}

inline void TComboBox::set_PPopupTr (ControlPtr value)
{
  //## begin TComboBox::set_PPopupTr%3FA254B601F7.set preserve=no
  PPopupTr = value;
  //## end TComboBox::set_PPopupTr%3FA254B601F7.set
}

inline const Int32 TComboBox::get_ItemIndex () const
{
  //## begin TComboBox::get_ItemIndex%3FA256480243.get preserve=no
  return ItemIndex;
  //## end TComboBox::get_ItemIndex%3FA256480243.get
}

inline void TComboBox::set_ItemIndex (Int32 value)
{
  //## begin TComboBox::set_ItemIndex%3FA256480243.set preserve=no
  ItemIndex = value;
  //## end TComboBox::set_ItemIndex%3FA256480243.set
}

//## begin module%3F9E5239017A.epilog preserve=yes
//## end module%3F9E5239017A.epilog


#endif
