#include "TDateEdit.hpp"
// Class TDateEdit 

TDateEdit::TDateEdit(const TDateEdit &right)
{
}

TDateEdit::TDateEdit (FieldPtr aPField)
{
  DateTimeType dateTime;
  PField = aPField;
  TimSecondsToDateTime (TimGetSeconds(), &dateTime);
  Date.day = dateTime.day;
  Date.month = dateTime.month;
  Date.year = dateTime.year;
  DateToField();
}


TDateEdit::~TDateEdit()
{
}


TDateEdit & TDateEdit::operator=(const TDateEdit &right)
{
}


int TDateEdit::operator==(const TDateEdit &right) const
{
}

int TDateEdit::operator!=(const TDateEdit &right) const
{
}

void TDateEdit::set_date (Int8 aday, Int8 amonth, Int8 ayear)
{
  Date.day = aday;
  Date.month = amonth;
  Date.year = ayear;
  DateToField();
}

void TDateEdit::set_Date (MyDateType value)
{
  Date = value;
  DateToField();
}


void TDateEdit::DateToField(void) //    
{  
	MemHandle h;
	UInt32 size;
    Char *n;
		
    h = FldGetTextHandle(PField); 
	if (h == NULL){ 
  	  h = MemHandleNew(11);
	}  
	size = MemHandleSize(h); 
	if (size < 11){
	  MemHandleResize (h, 11); 
	}
  	n = (Char *) MemHandleLock(h);
	
    DateToStr(Date.day, Date.month, Date.year, n);
    MemHandleUnlock(h);
    FldSetTextHandle(PField, h);	  
    FldDrawField(PField);
}   
Boolean TDateEdit::OnfldEnter(EventPtr event)
{   Char *title;

    title = (Char *)MemPtrNew(11);
    title = StrCopy(title, " \0");/**/
    SelectDay (selectDayByDay, (Int16 *)&Date.month, (Int16 *)&Date.day, (Int16 *)&Date.year, title);
    MemPtrFree(title);
	
	DateToField(); //    
}	     
