#include "TList.hpp"
// Class TList 
TList::TList()
{ 
  Items = NULL;
}

TList::TList(const TList &right)
{
}


TList::~TList()
{
  TListItem *prev, *temp;
  //   
  temp = Items;
  prev = temp; 
  while (temp) {
    temp = temp->next;
	delete prev;
	prev = temp; 
  }
  Items = NULL;

}


TList & TList::operator=(const TList &right)
{
}


int TList::operator==(const TList &right) const
{
}

int TList::operator!=(const TList &right) const
{
}



Boolean TList::Add (MemPtr item)
{
  TListItem *newItem, *temp;
  
  newItem = new TListItem;
  newItem->data = item;
  newItem->next = NULL;
  if (Items == NULL) Items = newItem;
  else
  {
    temp = Items; 
    while (temp->next) temp = temp->next;
	temp->next = newItem;
  } 
  return true;
  

}

Int32 TList::Count()
{ Int32 count;
  TListItem *temp;
  count = 0;
  if (Items == NULL) return count;
  temp = Items; 
  while (temp) {
    ++count; 
	temp = temp->next;
  }
  return count;
}

MemPtr TList::Item(Int32 index)
{
  Int32 count;
  TListItem *temp;
  
  if (index >= Count()) return NULL;
  count = 0;
  temp = Items; 
  while (temp) {
	if (count == index) return temp->data;
    ++count; 
	temp = temp->next;
  }
  
}
Boolean TList::Delete(Int32 index)
{
  Int32 count;
  TListItem *temp, *prev;
  
  if (index >= Count()) return NULL;
  if (index == 0){
    prev = Items;
    Items = Items->next; 
	delete prev;
    return true;
  }
  count = 0;
  temp = Items; 
  while (temp) {
	if (count == index) {
	  // 
	  prev->next = temp->next;
	  delete temp;
	  return true;
	}
	prev = temp;
	temp = temp->next;
    ++count; 
  }
  return false;
}
