#ifndef TList_h
#define TList_h 1
#include <PalmOS.h> 

typedef struct TListItem{
  MemPtr data;
  TListItem *next;       //  
} TListItem; 

class TList 
{
  public:
      TList();

      TList(const TList &right);

      ~TList();
	  
      TList & operator=(const TList &right);

      int operator==(const TList &right) const;

      int operator!=(const TList &right) const;


	  Boolean Add (MemPtr item);
	  Int32 Count();
      MemPtr Item(Int32 index);
      Boolean Delete(Int32 index);
  protected:
  private:
  private:
      TListItem *Items;
};
#endif
