#include "TProgressBar.hpp"
// Class TProgressBar 
UInt32 scrMode = 4; // 16bpp (1/2/4/8/16)


TProgressBar::TProgressBar()
      : wRec(3),
        hRec(2),
        wProgress(130)
{
  frm = NULL;
}

TProgressBar::TProgressBar(const TProgressBar &right)
      : wRec(3),
        hRec(2),
        wProgress(130)
{
}


TProgressBar::~TProgressBar()
{
  /*if (frm) { 
    FrmDeleteForm(frm);
	frm = NULL;
  }*/	 

}


TProgressBar & TProgressBar::operator=(const TProgressBar &right)
{
}


int TProgressBar::operator==(const TProgressBar &right) const
{
}

int TProgressBar::operator!=(const TProgressBar &right) const
{
  //## begin TProgressBar::operator!=%3F9E233A0139_neq.body preserve=yes
  //## end TProgressBar::operator!=%3F9E233A0139_neq.body
}



UInt16 TProgressBar::Start (Int32 pos, Int32 max, char str[50])
{
    RectangleType rm;
	Int32 left;
    Int32 lPos;
	Int32 i;
	Int32 rectPos;
	
	WinScreenMode( winScreenModeSet, 0, 0, &scrMode, 0 );
	
	rectCount = wProgress/(wRec + 1);
	r.extent.x = 160 - 20; 
	r.extent.y = 30;
	r.topLeft.x = (160 - r.extent.x) / 2; 
	r.topLeft.y = (160 - r.extent.y) / 2;
	frm = FrmGetActiveForm(); 
	//FrmNewForm (1234, str, r.topLeft.x, r.topLeft.y, r.extent.x, r.extent.y, 
	//frm = FrmNewForm (1234, str, 0, 20, 160, 140, 
	//  true, 0, 0, 0);
	//r.topLeft.x = 0; 
	//r.topLeft.y = 0;
	//FrmSetActiveForm(frm);   
	
	rm.extent.x = r.extent.x - 2; 
	rm.extent.y = r.extent.y - 2;
	rm.topLeft.x = r.topLeft.x + 1; 
	rm.topLeft.y = r.topLeft.y + 1;
	
	WinSetForeColor (0);
    WinDrawRectangle (&rm, 0);
	WinSetForeColor (15);

    WinDrawRectangle (&r, 10);
	WinSetForeColor (0);
    WinDrawRectangle (&rm, 10);
	WinSetForeColor (15);
	
	Max = max;
	curRectPos = 0;
	Pos = 0;
	Progress(pos, str);
/*	left = r.topLeft.x + (r.extent.x - FntLineWidth (str, StrLen(str)))/2;
	WinDrawChars (str, StrLen(str), left, r.topLeft.y + 3 );
	
	//  
	lPos = Max % pos;
	rectPos = lPos * rectCount / Max;  
	if 	(rectPos != curRectPos){
      for(i = 0; i < rectPos; ++i){
		rm.extent.x = wRec; 
		rm.extent.y = hRec;
		rm.topLeft.x = r.topLeft.x + 5 + i*(wRec + 1); 
		rm.topLeft.y = r.topLeft.y + 20;
	    WinDrawRectangle (&rm, 0);
	  }  
	}

	*/
	return 0; 
}

UInt16 TProgressBar::Progress (Int32 pos, char str[50])
{	Int32 left;
    Int32 lPos;
	Int32 rectPos;
	Int32 i;
	RectangleType rm;
	
	Pos = pos;
	//lPos = max % pos;
	if  (StrLen(str)!=0){
		rm.extent.x = r.extent.x - 2; 
		rm.extent.y = 15;
		rm.topLeft.x = r.topLeft.x + 1; 
		rm.topLeft.y = r.topLeft.y + 1;
		WinSetForeColor (0);
	    WinDrawRectangle (&rm, 10);
		left = r.topLeft.x + (r.extent.x - FntLineWidth (str, StrLen(str)))/2;
		WinDrawChars (str, StrLen(str), left, r.topLeft.y + 3 );
	}
		
	if (Max <= 0) Max = 1;
	lPos = pos % Max;
	/*if (pos != 0) lPos = pos % Max;
	else lPos = 0;*/
	
	WinSetForeColor (15);
	rectPos = lPos * rectCount / Max + 1;  
	if 	(rectPos != curRectPos){
      for(i = curRectPos; i <= rectPos; ++i){
		rm.extent.x = wRec; 
		rm.extent.y = hRec;
		rm.topLeft.x = r.topLeft.x + 5 + i*(wRec + 1); 
		rm.topLeft.y = r.topLeft.y + 20;
	    WinDrawRectangle (&rm, 0);
	  }
	  curRectPos = rectPos; 
	}    
	return 0; 
}

UInt16 TProgressBar::Progress()
{
  Progress(Pos + 1, "");
}

UInt16 TProgressBar::Finish ()
{
    WinEraseRectangle(&r, 10);
	if (frm) 
	  FrmDrawForm(frm);	 
	return 0; 
}

