 
/************************************************************************
 *
 * Created with Falch.net DeveloperStudio
 * http://www.falch.net/
 * 
 * File : frmMain.cpp
 * 
 * Description :  
 *
 * History:
 *			Name		Date					Description
 *			----		----					-----------
 *			U_60OTR	02.10.03 11:35:09		Created

 *
 ***********************************************************************/
/*
#include <PalmOS.h>
#include "FinDiagrCPP.hpp"
#include "FinDiagrCPP_res.hpp"   
#include "TDBGrid.hpp"
//#include "TDataSet.hpp"
#include "TProgressBar.hpp"


static TDBGrid *DBGrid = NULL;
TDataSet *DS_AccTo = NULL;
TDataSet *DS_Trans = NULL;
TDataSet *DS_AccFr = NULL;
UInt32 tmp = 4; // 16bpp (1/2/4/8/16)

Boolean ValidateRec(TDataSet *dataset)
{
  return true;
}

Boolean Initialization(void)
{
    TablePtr tableP;
	FormPtr form;
    UInt16 iIndex;
	ScrollBarPtr ScrollBarP;
	UInt32 val1,val2;
	Char *p;
	TField *field, *fldAccIDTo, *fldAccIDFrom, *fldAccNameFrom, *fldAccNameTo,
	  *ACC_TO_ID, *AMOUNT, *NOTE, *DATE, *ID, *FMIRROR;
	
	
	  
    form = FrmGetActiveForm();
	tableP = (TablePtr)FrmGetObjectPtr(form, FrmGetObjectIndex(form, tblTrans));
	ScrollBarP = (ScrollBarPtr)FrmGetObjectPtr(form, FrmGetObjectIndex(form, sclTable));

	
	//DS_AccFr = new TDataSet;
	
	DS_AccTo->set_DB_NAME("FP_Account");
	DS_AccTo->set_DB_CREATOR("IDfp");
	DS_AccTo->set_DB_CARDNO(0);

	fldAccIDTo = DS_AccTo->AddField ("ID", fdtInt, 4); 
	DS_AccTo->AddField ("Amt", fdtCurrency, 4); 
	DS_AccTo->AddField ("_1", fdtOther, 6); 
	fldAccNameTo = DS_AccTo->AddField ("", fdtChar, 30);
	 
	
	DS_Trans->set_DB_NAME("FP_Transaction");
	DS_Trans->set_DB_CREATOR("IDfp");
	DS_Trans->set_DB_CARDNO(0);
	
	ID = DS_Trans->AddField ("ID", fdtInt, 4);
	field = DS_Trans->AddField ("MIRROR_ID", fdtInt, 4);
	ACC_TO_ID = DS_Trans->AddField ("ACC_TO_ID", fdtInt, 4);
	field = DS_Trans->AddField ("ACC_FROM_ID", fdtInt, 4);
	AMOUNT = DS_Trans->AddField ("AMOUNT", fdtCurrency, 4);
	field = DS_Trans->AddField ("CURRENCY_ID", fdtInt, 4);
	field = DS_Trans->AddField ("CURRENCY_RATE", fdtFloat, 4);
	field = DS_Trans->AddField ("REMINDTYPE_ID", fdtInt, 4);
	field = DS_Trans->AddField ("BALANCETYPE_ID", fdtInt, 4);
	field = DS_Trans->AddField ("CATEGORY1_ID", fdtInt, 4);
	field = DS_Trans->AddField ("CATEGORY2_ID", fdtInt, 4);
	field = DS_Trans->AddField ("CATEGORY3_ID", fdtInt, 4);
	field = DS_Trans->AddField ("CATEGORY4_ID", fdtInt, 4);
//  UInt16 second;
//  UInt16 minute;
//  UInt16 hour;
	field = DS_Trans->AddField ("Time", fdtOther, 6);
//  UInt16 day;
//  UInt16 month;
//  UInt16 year;
//  UInt16 weekDay; // 14    
	DATE = DS_Trans->AddField ("", fdtDate, 8);
	field = DS_Trans->AddField ("FOWNCURRENCY", fdtInt, 1);
	field = DS_Trans->AddField ("FADD", fdtInt, 1);
	//FMIRROR = DS_Trans->AddField ("FMIRROR", fdtInt, 1);
	FMIRROR = DS_Trans->AddMemField ("MemFMIRROR", fdtInt, 1);
	field = DS_Trans->AddField ("FREMIND", fdtInt, 1);
	field = DS_Trans->AddField ("FRECEIPT", fdtInt, 1);
	field = DS_Trans->AddField ("FBILLABLE", fdtInt, 1);
	field = DS_Trans->AddField ("FCLEARED", fdtInt, 1);
	NOTE = DS_Trans->AddField ("NOTE", fdtChar, 30); 

	
    DS_AccTo->SetLinkDS(ACC_TO_ID, fldAccIDTo);
	
	DBGrid->AddColumn(DATE, customTableItem, NULL);
    DBGrid->AddColumn(fldAccNameTo, customTableItem, NULL);
    //DBGrid->AddColumn(fldAccNameTo, labelTableItem, NULL);
	DBGrid->AddColumn(AMOUNT, customTableItem, NULL);
	//DBGrid->AddColumn(NOTE, textTableItem, NULL);
	DBGrid->AddColumn(FMIRROR, checkboxTableItem, NULL);
	
	//DBGrid->AddColumn(ACC_TO_ID, textTableItem, NULL);
	  
	

	DS_AccTo->Open();
	DS_Trans->Open();
	//fldAccIDTo->DS->GetFieldDataHandle(fldAccIDTo, &p);
	//DS_AccFr->set_dbPtr(DS_AccTo->get_dbPtr());
	val1 = 78;
	val2 = 79;
	DS_Trans->OnFuncValidateRecType = &ValidateRec;
	DS_Trans->AddFilterMemb(ACC_TO_ID, (Char *)&val1, etEqual);
	DS_Trans->AddFilterMemb(ACC_TO_ID, (Char *)&val2, etEqual);
	DS_Trans->set_Filtered(true);
	DBGrid->InitGrid();
	
}

static Boolean lPrgCallbackFunc(PrgCallbackDataPtr cbP)
{  Char mess[50];
  
  //StrPrintF(mess, "Update '%d'  ", 0);
  cbP->textP = cbP->message;
  cbP->textLen = StrLen(cbP->message);
  //SysFatalAlert (cbP->message);
  return true;
}

static Boolean frmMain_btnClose_OnSelect(EventPtr event)
{  //ProgressPtr prgP;
   Int16 i;
   Char mess[50];
   TProgressBar *prgP;
   
   prgP = new TProgressBar; 
   StrPrintF(mess, "Update '%d'  ", 1);
   prgP->Start(0, 100, mess);
   for(i = 0; i < 100; ++i){
  	 //SysFatalAlert (mess);
     StrPrintF(mess, "Update '%d'  ", i);
     prgP->Progress(i, mess);
     //PrgUpdateDialog (prgP, 0, i, mess, true);  
   }
   prgP->Finish();
   delete prgP; 
   //PrgStopDialog (prgP, true); 
}


Boolean frmMain_HandleEvent(EventPtr event)
{
	FormPtr form;
	Boolean handled = false;
    UInt16 scrlIndex;
	ScrollBarPtr ScrollBarP;
	
	switch (event->eType)
	{
		case ctlSelectEvent:
			switch (event->data.ctlSelect.controlID)
			{
				// btnClose receives an event
				case btnClose:
					handled = frmMain_btnClose_OnSelect(event);
					break;
			}
			break;
		case frmCloseEvent:
			// Insert code when form closes:
		    if (DBGrid) delete DBGrid;
		    if (DS_AccTo) delete DS_AccTo;
		    if (DS_AccFr) delete DS_AccFr;
		    if (DS_Trans) delete DS_Trans;
			break;
		case sclExitEvent :
			switch (event->data.sclExit.scrollBarID)
			{
				// sclTable receives an event
				case sclTable:
				
					handled = DBGrid->sclExitEventHandler(event); 
					//frmMain_sclTable_OnScrollbarExit(event);
					
					break;
			}
			break;
		case frmOpenEvent:
			// Repaint form on open
            WinScreenMode( winScreenModeSet, 0, 0, &tmp, 0 );
			form = FrmGetActiveForm();
			Initialization();
			
			FrmDrawForm(form);
			handled = true;
			break;
		default:
			break;
	}

	return handled;
}
*/