#ifndef COMMONFUNC_H_INCLUDED
#define COMMONFUNC_H_INCLUDED
#include <PalmOS.h>
#include "Sections.hpp"

typedef struct{
  Int16 day;
  Int16 month;
  Int16 year;
  Int16 weekDay ; //Days since Sunday (0 to 6)
} MyDateType; 
  
typedef MyDateType *MyDatePtr; 



/*
      str ("16.17.2003"),  , , 
*/
Boolean StrToDate(Char *str, Int16 *day, Int16 *month, Int16 *year) SECT1;
/*
   StrToDate
*/
Boolean DateToStr(Int16 day, Int16 month, Int16 year, Char *str) SECT1;

Int32 DaysBeetwin(MyDatePtr FrDate, MyDatePtr ToDate)  SECT1;

Int32 MonthsBeetwin(MyDatePtr FrDate, MyDatePtr ToDate)  SECT1;
Int16 GetDayOfWeek(MyDatePtr lDate) SECT1;


Boolean DateToMyDate(DateType *date, MyDatePtr mdate)  SECT1;
Boolean MyDateToDate(MyDatePtr mdate, DatePtr date)  SECT1;
/*
   
  0 -  
  1 - Date1 > Date2
  -1 - Date1 < Date2
*/
Int8 CompareMyDate(MyDatePtr Date1, MyDatePtr Date2)  SECT1;
void FloatToCurrency(FlpCompFloat flp, Char *p, Int8 dec);
void ClearMem(Char *p, UInt32 len)  SECT1;
//     
UInt16 GetObjectIndexFromPtr (const FormType *formP, void *objP) SECT1;
Boolean DayAdjust(MyDatePtr myDate, Int32 IncDay)  SECT1;
Boolean MonthAdjust(MyDatePtr myDate, Int32 IncMonth);


#endif
