#ifndef TDBGrid_h
#define TDBGrid_h 1


#include "TDataSet.hpp"

#define cMaxColCount 10

struct TColumnData{
      //Char FieldName[30]; 
	  TableItemStyleType itemtype; 	//   
	  TField *field;
      //TFldDataType fieldtype; 	//  :
	  //UInt16 DataLen;           //  
      //Boolean enabled;
	  TableLoadDataFuncPtr loadDataCallback;
	  };


class TDBGrid 
{
  //## begin TDBGrid%3F7D320B02BC.initialDeclarations preserve=yes
  //## end TDBGrid%3F7D320B02BC.initialDeclarations

  public:
    //## Constructors (generated)
      TDBGrid();

      TDBGrid(const TDBGrid &right);

    //## Constructors (specified)
      //## Operation: TDBGrid%3F7D32850129
      TDBGrid (ScrollBarPtr pscrollbar, TablePtr ptable, TDataSet *dataset);

    //## Destructor (generated)
      ~TDBGrid();

    //## Assignment Operation (generated)
      TDBGrid & operator=(const TDBGrid &right);

    //## Equality Operations (generated)
      int operator==(const TDBGrid &right) const;

      int operator!=(const TDBGrid &right) const;


    //## Other Operations (specified)
      //## Operation: AddColumn%3F7D36800134
      void AddColumn (TField *field, 	// 
	    TableItemStyleType itemtype, 	//   
		TableLoadDataFuncPtr loadDataCallback);
		
      /*void AddColumnByField (Char fieldname[30], TableItemStyleType itemtype, 	//   
	    Boolean enabled,
		TableLoadDataFuncPtr loadDataCallback);*/

	  //    sclExitEvent  ScrollBar   Grid,       	
 	  Boolean sclExitEventHandler(EventPtr event);
      //     CheckBox' 
      Boolean tblSelectEventHandler(EventPtr event);
      Boolean keyDownEventHandler(EventPtr event);
	  
	  
	  void Refresh(void);	

      void InitGrid(void);
	  
	  //UInt16 GetUseColCount(void); //    
    //## Get and Set Operations for Class Attributes (generated)

      const TablePtr get_PTable () const;
      void set_PTable (TablePtr value);

      const ScrollBarPtr get_PScrollBar () const;
      void set_PScrollBar (ScrollBarPtr value);

      const TDataSet get_DataSet () const;
      void set_DataSet (TDataSet *value);
	  
      TablePtr PTable;
	  Int32 StartPos; //   .    Grid
      TDataSet *DataSet; //   
	  struct TColumnData columns[10];
	  UInt16 ColumnCount; //  MaxColCount
  protected:
    // Additional Protected Declarations
      //## begin TDBGrid%3F7D320B02BC.protected preserve=yes
      //## end TDBGrid%3F7D320B02BC.protected

  private:
    // Additional Private Declarations
      //## begin TDBGrid%3F7D320B02BC.private preserve=yes
      //## end TDBGrid%3F7D320B02BC.private

  private: //## implementation
    // Data Members for Class Attributes


      ScrollBarPtr PScrollBar;
	  
	  
	  UInt16 MaxColCount; //        
	  UInt16 MaxRowCount;
	  UInt16 UseRowCount; //   
	  UInt16 DSRecCount; //     
	  
	  /*Err loadProc(void *tableP, Int16 row, Int16 column, Boolean editable, 
            MemHandle * dataH, Int16 *dataOffset, Int16 *dataSize, FieldPtr fld);*/
			
};

// Class TDBGrid 
inline const TablePtr TDBGrid::get_PTable () const
{
  //## begin TDBGrid::get_PTable%3F7D32230108.get preserve=no
  return PTable;
  //## end TDBGrid::get_PTable%3F7D32230108.get
}

inline void TDBGrid::set_PTable (TablePtr value)
{
  //## begin TDBGrid::set_PTable%3F7D32230108.set preserve=no
  PTable = value;
  //## end TDBGrid::set_PTable%3F7D32230108.set
}

inline const ScrollBarPtr TDBGrid::get_PScrollBar () const
{
  //## begin TDBGrid::get_PScrollBar%3F7D3242029E.get preserve=no
  return PScrollBar;
  //## end TDBGrid::get_PScrollBar%3F7D3242029E.get
}

inline void TDBGrid::set_PScrollBar (ScrollBarPtr value)
{
  //## begin TDBGrid::set_PScrollBar%3F7D3242029E.set preserve=no
  PScrollBar = value;
  //## end TDBGrid::set_PScrollBar%3F7D3242029E.set
}
inline const TDataSet TDBGrid::get_DataSet () const
{
  //## begin TDBGrid::get_DataSet%3F7D4EBE022C.get preserve=no
  return *DataSet;
  //## end TDBGrid::get_DataSet%3F7D4EBE022C.get
}

inline void TDBGrid::set_DataSet (TDataSet *value)
{
  //## begin TDBGrid::set_DataSet%3F7D4EBE022C.set preserve=no
  DataSet = value;
  //## end TDBGrid::set_DataSet%3F7D4EBE022C.set
}


#endif