
#ifndef TProgressBar_h
#define TProgressBar_h 1

#include <PalmOS.h> 

class TProgressBar 
{

  public:
    //## Constructors (generated)
      TProgressBar();

      TProgressBar(const TProgressBar &right);

    //## Destructor (generated)
      ~TProgressBar();

    //## Assignment Operation (generated)
      TProgressBar & operator=(const TProgressBar &right);

    //## Equality Operations (generated)
      int operator==(const TProgressBar &right) const;

      int operator!=(const TProgressBar &right) const;


    //## Other Operations (specified)
      //## Operation: Start%3F9E26260234
      UInt16 Start (Int32 pos, Int32 max, char str[50]);

      //## Operation: Progress%3F9E2738020C
      UInt16 Progress (Int32 pos, char str[50]);
	  UInt16 Progress();

      //## Operation: Finish%3F9E276801A7
      UInt16 Finish ();

    //## Get and Set Operations for Class Attributes (generated)

      //## Attribute: Max%3F9E252D03D6
      //	//  
      const Int32 get_Max () const;
      void set_Max (Int32 value);

    // Additional Public Declarations
      //## begin TProgressBar%3F9E233A0139.public preserve=yes
      //## end TProgressBar%3F9E233A0139.public

  protected:
    // Additional Protected Declarations
      //## begin TProgressBar%3F9E233A0139.protected preserve=yes
      //## end TProgressBar%3F9E233A0139.protected

  private:
    //## Get and Set Operations for Class Attributes (generated)

      //## Attribute: curRectPos%3F9E23680353
      //	 
      const Int32 get_curRectPos () const;
      void set_curRectPos (Int32 value);

      //## Attribute: wRec%3F9E25B602BD
      //	//  
      const Int32 get_wRec () const;
      void set_wRec (Int32 value);

      //## Attribute: hRec%3F9E25D20368
      //	 
      const Int32 get_hRec () const;
      void set_hRec (Int32 value);

      //## Attribute: wProgress%3F9E25F00235
      //	 
      const Int32 get_wProgress () const;
      void set_wProgress (Int32 value);

      //## Attribute: rectCount%3F9E261102AC
      //	 
      const Int32 get_rectCount () const;
      void set_rectCount (Int32 value);

    // Additional Private Declarations
      //## begin TProgressBar%3F9E233A0139.private preserve=yes
      //## end TProgressBar%3F9E233A0139.private

  private: //## implementation
    // Data Members for Class Attributes

      Int32 curRectPos;
	  Int32 Pos;
      Int32 Max;
      Int32 wRec;
      Int32 hRec;
      Int32 wProgress;
      Int32 rectCount;
      RectangleType r;
	  FormType *frm;
};

//## begin TProgressBar%3F9E233A0139.postscript preserve=yes
//## end TProgressBar%3F9E233A0139.postscript

// Class TProgressBar 

//## Get and Set Operations for Class Attributes (inline)

inline const Int32 TProgressBar::get_curRectPos () const
{
  //## begin TProgressBar::get_curRectPos%3F9E23680353.get preserve=no
  return curRectPos;
  //## end TProgressBar::get_curRectPos%3F9E23680353.get
}

inline void TProgressBar::set_curRectPos (Int32 value)
{
  //## begin TProgressBar::set_curRectPos%3F9E23680353.set preserve=no
  curRectPos = value;
  //## end TProgressBar::set_curRectPos%3F9E23680353.set
}

inline const Int32 TProgressBar::get_Max () const
{
  //## begin TProgressBar::get_Max%3F9E252D03D6.get preserve=no
  return Max;
  //## end TProgressBar::get_Max%3F9E252D03D6.get
}

inline void TProgressBar::set_Max (Int32 value)
{
  //## begin TProgressBar::set_Max%3F9E252D03D6.set preserve=no
  Max = value;
  //## end TProgressBar::set_Max%3F9E252D03D6.set
}

inline const Int32 TProgressBar::get_wRec () const
{
  //## begin TProgressBar::get_wRec%3F9E25B602BD.get preserve=no
  return wRec;
  //## end TProgressBar::get_wRec%3F9E25B602BD.get
}

inline void TProgressBar::set_wRec (Int32 value)
{
  //## begin TProgressBar::set_wRec%3F9E25B602BD.set preserve=no
  wRec = value;
  //## end TProgressBar::set_wRec%3F9E25B602BD.set
}

inline const Int32 TProgressBar::get_hRec () const
{
  //## begin TProgressBar::get_hRec%3F9E25D20368.get preserve=no
  return hRec;
  //## end TProgressBar::get_hRec%3F9E25D20368.get
}

inline void TProgressBar::set_hRec (Int32 value)
{
  //## begin TProgressBar::set_hRec%3F9E25D20368.set preserve=no
  hRec = value;
  //## end TProgressBar::set_hRec%3F9E25D20368.set
}

inline const Int32 TProgressBar::get_wProgress () const
{
  //## begin TProgressBar::get_wProgress%3F9E25F00235.get preserve=no
  return wProgress;
  //## end TProgressBar::get_wProgress%3F9E25F00235.get
}

inline void TProgressBar::set_wProgress (Int32 value)
{
  //## begin TProgressBar::set_wProgress%3F9E25F00235.set preserve=no
  wProgress = value;
  //## end TProgressBar::set_wProgress%3F9E25F00235.set
}

inline const Int32 TProgressBar::get_rectCount () const
{
  //## begin TProgressBar::get_rectCount%3F9E261102AC.get preserve=no
  return rectCount;
  //## end TProgressBar::get_rectCount%3F9E261102AC.get
}

inline void TProgressBar::set_rectCount (Int32 value)
{
  //## begin TProgressBar::set_rectCount%3F9E261102AC.set preserve=no
  rectCount = value;
  //## end TProgressBar::set_rectCount%3F9E261102AC.set
}

//## begin module%3F9E233A0139.epilog preserve=yes
//## end module%3F9E233A0139.epilog


#endif
